




<!DOCTYPE html>
<html>
<head>
<title>微信小程序中使用Async-await方法异步请求变为同步请求 -  码上快乐</title>
<meta name="keywords" content="Promise,Async/Await,微信小程序,JavaScript,ES7,ES6,Node.js,小程序" />
<meta name="description" content="微信小程序中有些 Api 是异步的，无法直接进行同步处理。例如：wx.request wx.showToast wx.showLoading等。如果需要同步处理，可以使用如下方法： 注意： Async await方法属于ES 语法，在小程序开发工具中如果勾选es 转es , 会报错： 避免报错，可以" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<meta http-equiv="X-UA-Compatible" content="ie=edge">
<meta http-equiv="Cache-Control" content="no-transform" />
<meta http-equiv="Cache-Control" content="no-siteapp" />
<meta name="applicable-device" content="pc,mobile">
<link href="/css/all.css?version=" rel="stylesheet">
<link href="/css/prettify.css?version=" rel="stylesheet">
</head>
<body onload="prettyPrint()">
    
<style>
.div2{top:45px;z-index:999;position:fixed;_position:absolute}
</style>
<div class="navbar navbar-inverse navbar-fixed-top">
	<div class="navbar-inner">
		<div class="container">
			<button data-target=".nav-collapse" data-toggle="collapse" class="btn btn-navbar" type="button">
				<span class="icon-bar"></span> 
				<span class="icon-bar"></span>
				<span class="icon-bar"></span>
			</button>
			<a class="brand" href="/index.html">码上快乐</a>
			<div class="nav-collapse collapse">
                <p class="navbar-text pull-right toplogin" style="margin-top:0px;">
	              <a href="javascript:void(0)" class="btn-show-login navbar-link">1秒登录</a>
	            </p>		
				<ul class="nav">
					<li class="navtop index"><a href="/index.html"><i class="icon-home icon-white"></i><strong>首页</strong></a></li>
					<li class="navtop recent"><a href="/rank.html"><i class="icon-fire icon-white"></i><strong>榜单</strong></a></li>
					<li class="navtop tags"><a href="/tags.html"><i class="icon-tag icon-white"></i><strong>标签</strong></a></li>
					<li class="navtop hot"><a href="/about.html"><i class="icon-heart icon-white"></i><strong>关于</strong></a></li>
					<li class="navtop hot"><a href="javascript:void(0);" rel="nofollow"><i class="icon-fire icon-white"></i><strong style="color:red" class="gptclass"></strong></a></li>
				</ul>
			</div>
		</div>
	</div>
</div>
<script src="/js/all.js?version="></script>

<!-- Global site tag (gtag.js) - Google Analytics -->

    <input name="ua" value="" type="hidden"/>
    <input name="title" value="微信小程序中使用Async-await方法异步请求变为同步请求" type="hidden"/>
	<div class="container" style="padding-top:20px;">
		<div class="row-fluid m_b_20">
		    
			<div class="span2 visible-desktop" id="logo">
				<center>
					<a href="/index.html"><img src="/img/logo.png?version=" class="h_30"/></a>
				</center>
			</div>
			<div class="span6">
				<form class="form-search" action="/so" name="search-form">
					<div class="input-append span10">
						<center>
							<input type="text" class="span12 search-query" name="q" placeholder=" 请输入关键词搜索..." baiduSug="1">
							<button type="submit" class="btn btn-warning">搜索</button>
						</center>
					</div>
				</form>
			</div>
			<div class="span4 visible-desktop">
			    <a class="btn" href="/recommend/9c1ff91/微信小程序中使用Async-await方法异步请求变为同步请求"><i class="icon-random"></i>相关内容</a>
			    &nbsp;&nbsp;<a class="btn" href="https://www.codeprj.com/blog/9c1ff91.html"><i class="icon-refresh"></i>简体</a>
			    &nbsp;&nbsp;<a class="btn" href="https://www.codeprj.com/zh/blog/9c1ff91.html"><i class="icon-refresh"></i>繁体</a>
				
			</div>
		</div>
		<div class="row-fluid">
		    
			<div class="span8">
			    <div class="content_div">
			      <center>
			      <h3><a href="/blog/9c1ff91.html" style="color:black">微信小程序中使用Async-await方法异步请求变为同步请求</a></h3>
			      </center>
			      <div class="postinfo">
			              本文转载自
			      
			      <i class="icon-globe"></i>&nbsp;<a href="/go/aHR0cHM6Ly93d3cuY25ibG9ncy5jb20vY2NrdWkvcC8xMDIzMTgwMS5odG1s" target="_blank">查看原文</a>
			      <i class="icon-time"></i>&nbsp;<span>2019-01-07 10:31</span>
			      <i class="icon-eye-open"></i>&nbsp;<span>33890&nbsp;</span>
                  
                     <i class="icon-tag"></i>&nbsp;
                     
                     
                     
                     <span><a href='/tag/Promise' target="_blank">Promise</a>/</span>
                                          
                     
                     <span><a href='/tag/Async／Await' target="_blank">Async/Await</a>/</span>
                                          
                     
                     <span><a href='/tag/微信小程序' target="_blank">微信小程序</a>/</span>
                                          
                     
                     <span><a href='/tag/JavaScript' target="_blank">JavaScript</a>/</span>
                                          
                     
                     <span><a href='/tag/ES7' target="_blank">ES7</a>/</span>
                                          
                     
                     <span><a href='/tag/ES6' target="_blank">ES6</a>/</span>
                                          
                     
                     <span><a href='/tag/Node.js' target="_blank">Node.js</a>/</span>
                                          
                     
                     
                     <span><a href='/tag/小程序' target="_blank">小程序</a></span>                     
                     
                  
                  <i class="icon-star" title="58.9481"></i>
                  <i class="icon-star" title="58.9481"></i>
                  <i class="icon-star" title="58.9481"></i>
                  <i class="icon-star" title="58.9481"></i>
                  <i class="icon-star" title="58.9481"></i>                  
			      </div>
			      <hr/>
                 <div class="media-body" id="content_div">
                    <div class="title_down_ad ad">
					</div>
					<div class="post_content" id="postContent">
					  <p>微信小程序中有些 Api 是异步的，无法直接进行同步处理。例如：<a href="/link/aHR0cHM6Ly9kZXZlbG9wZXJzLndlaXhpbi5xcS5jb20vbWluaXByb2dyYW0vZGV2L2FwaS93eC5yZXF1ZXN0Lmh0bWw=" rel="nofollow noopener" target="_blank">wx.request</a>、<a href="/link/aHR0cHM6Ly9kZXZlbG9wZXJzLndlaXhpbi5xcS5jb20vbWluaXByb2dyYW0vZGV2L2FwaS93eC5zaG93VG9hc3QuaHRtbA==" rel="nofollow noopener" target="_blank">wx.showToast</a>、<a href="/link/aHR0cHM6Ly9kZXZlbG9wZXJzLndlaXhpbi5xcS5jb20vbWluaXByb2dyYW0vZGV2L2FwaS93eC5zaG93TG9hZGluZy5odG1s" rel="nofollow noopener" target="_blank">wx.showLoading</a>等。如果需要同步处理，可以使用如下方法：</p> 
<h2 id="注意：">注意：</h2> 
<p>Async-await方法属于ES7语法，在小程序开发工具中如果勾选es6转es5, 会报错：</p> 
<pre><code>ReferenceError: regeneratorRuntime is not defined
</code></pre> 
<p>避免报错，可以引入 <a href="/link/aHR0cHM6Ly9naXRodWIuY29tL2ZhY2Vib29rL3JlZ2VuZXJhdG9y" rel="nofollow noopener" target="_blank">regenerator</a></p> 
<ol> 
 <li> <p>在根目录下创建 lib 文件夹，并将 <a href="/link/aHR0cHM6Ly9naXRodWIuY29tL2ZhY2Vib29rL3JlZ2VuZXJhdG9yL3RyZWUvbWFzdGVyL3BhY2thZ2Vz" rel="nofollow noopener" target="_blank">https://github.com/facebook/regenerator/tree/master/packages</a> 里面的 regenerator-runtime 文件夹放进去。</p> </li> 
 <li> <p>然后在使用async-awiat的页面中引入：</p> </li> 
</ol> 
<pre><code>// pages/list/list.js

const regeneratorRuntime = require('../../lib/regenerator-runtime/runtime')
</code></pre> 
<br> 
<img src="/image/aHR0cHM6Ly93d3cuY25ibG9ncy5jb20vaW1hZ2VzL2NuYmxvZ3NfY29tL2Nja3VpLzExMDc5NTIvb18lZTclOWIlYWUlZTUlYmQlOTUuanBn.png" width="300" referrerpolicy="no-referrer"> 
<br> 
<h2 id="同步处理异步请求">同步处理异步请求</h2> 
<h4 id="在根目录下新建api文件夹，里面新建indexjs">在根目录下新建api文件夹，里面新建index.js</h4>
<ins class="adsbygoogle" style="display:block; text-align:center;" data-ad-layout="in-article" data-ad-format="fluid" data-ad-client="ca-pub-4353345653789615" data-ad-slot="4890554435"></ins>
<script>     (adsbygoogle = window.adsbygoogle || []).push({});</script> 
<pre><code>// request get 请求
const getData = (url, param) =&gt; {
  return new Promise((resolve, reject) =&gt; {
    wx.request({
      url: url,
      method: 'GET',
      data: param,
      success (res) {
        console.log(res)
        resolve(res.data)
      },
      fail (err) {
        console.log(err)
        reject(err)
      }
    })
  })
}

// request post 请求
const postData = (url, param) =&gt; {
  return new Promise((resolve, reject) =&gt; {
    wx.request({
      url: url,
      method: 'POST',
      data: param,
      success (res) {
        console.log(res)
        resolve(res.data)
      },
      fail (err) {
        console.log(err)
        reject(err)
      }
    })
  })
}

// loading加载提示
const showLoading = () =&gt; {
  return new Promise((resolve, reject) =&gt; {
    wx.showLoading({
      title: '加载中...',
      mask: true,
      success (res) {
        console.log('显示loading')
        resolve(res)
      },
      fail (err) {
        reject(err)
      }
    })
  })
}

// 关闭loading
const hideLoading = () =&gt; {
  return new Promise((resolve) =&gt; {
    wx.hideLoading()
    console.log('隐藏loading')
    resolve()
  })
}

module.exports = {
  getData,
  postData,
  showLoading,
  hideLoading
}
</code></pre> 
<h4 id="在入口文件-appjs-中引入：">在入口文件 app.js 中引入：</h4> 
<pre><code>//app.js 
const api = require('./api/index')

App({
  onLaunch: function () {
  
  },
  // 全局数据中暴露api
  globalData: { 
    api
  }
})

</code></pre> 
<h4 id="在需要使用api-的页面中处理如下：">在需要使用api 的页面中处理如下：</h4>
<ins class="adsbygoogle" style="display:block; text-align:center;" data-ad-layout="in-article" data-ad-format="fluid" data-ad-client="ca-pub-4353345653789615" data-ad-slot="4890554435"></ins>
<script>     (adsbygoogle = window.adsbygoogle || []).push({});</script> 
<pre><code>// pages/list/list.js
const app = getApp()

const api = app.globalData.api

Page({
    
  onLoad () {
    this.init()
  },

  // 初始化
  async init () {
    await api.showLoading() // 显示loading
    await this.getList()  // 请求数据
    await api.hideLoading() // 等待请求数据成功后，隐藏loading
  },

  // 获取列表
  getList () {
    return new Promise((resolve, reject) =&gt; {
      api.getData('http://127.0.0.1:3000/list', {
          x: '',
          y: ''
      }).then((res) =&gt; {
        this.setData({
          list: res
        })
        console.log(res)
        resolve()
      })
        .catch((err) =&gt; {
          console.error(err)
          reject(err)
        })
    })
  },
    
})

</code></pre> 
<blockquote> 
 <p>参考：<a href="/link/aHR0cHM6Ly93d3cuY25ibG9ncy5jb20vY2NrdWkvcC85OTE1NjA0Lmh0bWw=" rel="nofollow noopener" target="_blank">https://www.cnblogs.com/cckui/p/9915604.html</a></p> 
</blockquote> 
<h1 id="--友情推荐">👉 友情推荐</h1> 
<h3 id="新开发的小程序，功能包括诗词大全、成语接龙、百家姓、猜字谜、歇后语，欢迎扫码预览：">新开发的小程序，功能包括诗词大全、成语接龙、百家姓、猜字谜、歇后语，欢迎扫码预览：</h3> 
<br> 
<img src="/image/aHR0cHM6Ly93d3cuY25ibG9ncy5jb20vaW1hZ2VzL2NuYmxvZ3NfY29tL2Nja3VpLzExMDc5NTIvb19XZWNoYXRJTUc3MzIuanBn.png" width="280" referrerpolicy="no-referrer"> 
<br>
					</div>      
                    <div class="read-more" id="read-more" style="display:none"></div>        
                    <div class="alert alert-info" style="margin-top:20px;">
				      <p id="tips_top1">
				      </p>
			        </div>
			        <script type="text/javascript">
			         $("#tips_top1").append("<strong><i class=\"icon-fire\"></i>温馨提示：</strong>如果本文未解决您的问题，可以免费向大模型提问：<strong><a href='javascript:void(0)' class='gptbtn'>向AI大模型提问</a></strong>。");
			        </script>				        
					<div class="iframe-container">
					</div>
                 </div>
                 
			      
			      <div class="ad_content_down ad">
			      </div>                 
			    </div>
			     
			     <div class="disclaimer visible-desktop">
			         <br/>
		             <div class="alert alert-block">
		              <button type="button" class="close" data-dismiss="alert">×</button>
		              <h4>免责声明！</h4>
		                 <p>本站转载的文章为个人学习借鉴使用，本站对版权不负任何法律责任。如果侵犯了您的隐私权益，请联系本站邮箱yoyou2525@163.com删除。</p>
		            </div>	
		            <br/><br/>
                 </div>
			</div>
			
			<!-- 右边相关博客和资料 -->
			<div class="span4 left_content">
			  <div id="left_list_div" class="left_content">
			   <span class="list-group-item" href="javascript:void(0)"><i class="icon-filter"></i><strong>猜您在找</strong></span>
			   
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/b17b421.html" title="使用 async await 封装微信小程序HTTP请求">
			           
			           <i class="icon-file"></i>
			           使用 async await 封装微信小程序HTTP请求
			           </a>
			       			       
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/d502f41.html" title="小程序中将异步请求变成同步请求">
			           
			           <i class="icon-file"></i>
			           小程序中将异步请求变成同步请求
			           </a>
			       			       
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/e401531.html" title="微信小程序中使用Promise实现异步请求">
			           
			           <i class="icon-file"></i>
			           微信小程序中使用Promise实现异步请求
			           </a>
			       			       
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/c719521.html" title="在微信小程序中使用 async/await">
			           <i class="icon-fire"></i>
			           
			           在微信小程序中使用 async/await
			           </a>
			       			       
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/c1fd5c1.html" title="微信小程序 使用async await">
			           
			           <i class="icon-file"></i>
			           微信小程序 使用async await
			           </a>
			       			       
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/9f5dd61.html" title="vue 中使用 async/await 将 axios 异步请求同步化处理">
			           <i class="icon-fire"></i>
			           
			           vue 中使用 async/await 将 axios 异步请求同步化处理
			           </a>
			       			       
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/c161ff1.html" title="vue 中使用 async/await 将 axios 异步请求同步化处理">
			           <i class="icon-fire"></i>
			           
			           vue 中使用 async/await 将 axios 异步请求同步化处理
			           </a>
			       			       
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/ba3a151.html" title="async-await使用方法">
			           
			           <i class="icon-file"></i>
			           async-await使用方法
			           </a>
			       			       
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/a1886a1.html" title="微信小程序异步请求解决方法">
			           
			           <i class="icon-file"></i>
			           微信小程序异步请求解决方法
			           </a>
			       			       
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/943ea71.html" title="微信小程序开发——使用promise封装异步请求">
			           <i class="icon-fire"></i>
			           
			           微信小程序开发——使用promise封装异步请求
			           </a>
			       			       
			   
			   
			   <div id="right_float_ad" class="ad">
				</div>
			</div>
			</div>
		</div>
	</div>
    <div class="clear">&nbsp;</div>
    



<div class="fbar" style="z-index:100">
	<div class="span7" style="color:grey;font-size:12px;">
	</div>
	<div class="pull-right">
		<span><a href="http://beian.miit.gov.cn" rel="nofollow" target="_blank">粤ICP备18138465号</a>&nbsp;&nbsp;</span><span>&copy; 2018-2024 CODEPRJ.COM </span> 
	</div>
</div>
<script src="/js/code.js?version=20240329"></script>
<script>
   function buffer(a, b, c) {
	    var d;
	    return function() {
	        if (d) return;
	        d = setTimeout(function() {
	            a.call(this),
	            d = undefined
	        },
	        b)
	    }
	} 

	(function() {
	    function e() {
	        var d = document.body.scrollTop || document.documentElement.scrollTop;
	        d > b ? (a.className = "div1 div2", c && (a.style.top = d - b + "px")) : a.className = "div1"
	    }
	    var a = document.getElementById("float");
	    if (a == undefined) return ! 1;
	    var b = 0,
	    c, d = a;
	    while (d) b += d.offsetTop,
	    d = d.offsetParent;
	    c = window.ActiveXObject && !window.XMLHttpRequest;
	    if (!c || !0) window.onscroll = buffer(e, 50, this)
	})(); 

</script>

<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?85c5e8e7b6167edfc87cb0607142e870";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

    
    
</body>
</html>